#include <glib.h>
#include <gmodule.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

static gboolean initialized = FALSE;

typedef struct _Module
{
	GModule *module;
	int (*map_window) (Display *display, Window w);
	Status (*set_wm_hints) (Display *display, Window w, XWMHints *hints);

} Module;

extern int
XMapWindow (Display *display, Window w)
{
	static Module *module;
	XWMHints hints;
	if (!initialized) {
		module = g_new0 (Module, 1);
		module->module = g_module_open ("/usr/X11R6/lib/libX11.so.6", 0);
		if (!g_module_symbol (module->module, "XMapWindow",
					(gpointer *) &(module->map_window))) {
			return 0;
		}
		if (!g_module_symbol (module->module, "XSetWMHints",
					(gpointer *) &(module->set_wm_hints))) {
			return 0;
		}
		initialized = TRUE;
	}
	hints.flags = InputHint;
	hints.input = False;
	module->set_wm_hints (display, w, &hints);
	return module->map_window (display, w);
}
